module("luci.controller.novatec-network", package.seeall)

local mqtt = require "mosquitto"

function index()

    page = node("admin", "novatec")
		page.target = view("novatec-network/interfaces")
		page.title = _("Novatec Network")
		page.order = 75
		page.acl_depends = { "luci-mod-novatec-network-config" }

		page = entry({"admin", "novatec", "diagnostics_mqtt"}, call("novatec_mqtt_test"), nil)
		
		page.leaf = true

end

function novatec_mqtt_test()
  local status = 0
  client = mqtt.new()

  client.ON_CONNECT = function()
    client:disconnect()
  end

  client.ON_MESSAGE = function(client, userdata, msg)
  end

  client.ON_DISCONNECT = function()
    status = 1
  end
  
  local uci = require "luci.model.uci".cursor()
	local mqtt_host = uci:get_first("luci", "diag", "mqtt") or "mqtt-data.machinesense.com:8883"

  local mqtt_arr = split(mqtt_host, ":")
  local mqtt_port = 1883
  if mqtt_arr[2] then
    mqtt_port = tonumber(mqtt_arr[2])
  end

  client:connect(mqtt_arr[1], mqtt_port, 60)
  client:loop_forever()
  if status == 1 then
    luci.http.write('MQTT Connection is Up.')
  else 
    luci.http.write('MQTT Connection is Down.')
  end
end

function split(s, delimiter)
  result = {};
  for match in (s..delimiter):gmatch("(.-)"..delimiter) do
      table.insert(result, match);
  end
  return result;
end